<?php
include_once 'oauthClient.php';

//We start off with loading a file which registers the simpleSAMLphp classes with the autoloader.
require_once('utils/simplesamlphp/lib/_autoload.php');

//We select our authentication source:
$as = new SimpleSAML_Auth_Simple('default-sp');

//We then require authentication:
$as->requireAuth();
//And print the attributes:
$attributes = $as->getAttributes();
$assertion = $attributes;
$content="";
if($assertion=="") {
        $content.="<div class='error'>Usuario no autorizado.</div>";
}else{
        $sho =$assertion['urn:mace:dir:attribute-def:eduPersonScopedAffiliation'][0];
        $content .="<p>Por pertenecer a <b>'".$sho."'</b> puedes acceder a los siguientes servicios:";
        $client = new oauthConfig();
        //En localhost
        $oauth_as="https://localhost/oauth2/oauth_as/tokenEndpoint.php";
        $client->set_oauth_as($oauth_as);
       //Fin localhost
        $client->set_assertion_type("urn:saml2");
        $dev = $client->startFlow($assertion);
        if($dev!=null){
            $content .= drawServices($dev);
        }else{
            $content .= '<div class="error">Error: '.$client->getError().'</div>';
        }
}
include 'template.php';

/*Formatting functions*/
function drawServices($services){
        $xml = new SimpleXMLElement($services);
        $string = "";
        if(isset($xml->Error)){
                $string="No existen servicios asociados a tu organización o entidad.";
        }else{
                $string = "<div class='services'>";
                foreach($xml->ServiceProvider as $sp){
                        $string .= "<div class='service'>";
                        $nombre = $sp->Name;
                        $desc = $sp->Description;
                        $url = $sp->URL;
                        $techinfo = $sp->TechnicalInfo;
                        $wayfl = $sp->Wayfless;
                        $video = $sp->VideoTutorial;
                        $string .= '<div class="sp_name"><p><a href="'.$url.'">'.$nombre.'</a></p></div>';
                        $string .= '<div class="sp_desc"><p>'.$desc.'</p></div>';
                        $string .= '<div class="sp_techinfo"><p><a href="'.$techinfo.'">Detalles técnicos en la integración del recurso en SIR</a></p></div>';
                        if($wayfl!=""){
                                $string .= '<div class="sp_waifl"><p><a href="'.$wayfl.'">Acceso sin indicar de qué institución procedes.</a></p></div>';
                        }
                        if($video!=""){
                                $string .= '<div class="sp_video"><p><a href="'.$video.'">Video tutorial del servicio.</a></p></div>';
                        }
                        $string.="</div>";
                        }
                        $string.="</div>";
        }

        /*
        *  <Response>: es el elemento XML raíz de toda la respuesta.
    * <ServiceProvider>: es el elemento que describe un proveedor de servicio. Puede aparecer de 0 a N veces.
          o Atributo 'id': indica el Id del proveedor de servicio.
          o Atributo 'protocol': indica el protocolo utilizado para conectarse a dicho proveedor de servicio.
          o Atributo 'category': indica la categoría en la que ha sido clasificado el recurso.
    * <Name>: indica el nombre del proveedor de servicio.
    * <Descripción>: descripción del recurso.
    * <URL>: es la URL de entrada al proveedor de servicio.
    * <TechnicalInfo>: es la URL donde se pueden consultar los detalles técnicos en la integración del recurso en SIR.
    * <Wayfless>: es la URL a través de la cual se puede acceder al recurso sin que el usuario tenga que indicar de qué institución procede. Este elemento no aparecerá si no hay una solución técnica para ofrecer dicha URL.
    * <VideoTutorial>: es la URL de un video que explica al usuario como conectarse al recurso a través de SIR. Este elemento no aparecerá si no hay dicho video para el recurso.

        */

        return $string;
}
?>  